import type { OutputFormat, Config } from '@redocly/openapi-core';
export type PushOptions = {
    apis?: string[];
    organization?: string;
    project: string;
    'mount-path': string;
    branch: string;
    author: string;
    message: string;
    'commit-sha'?: string;
    'commit-url'?: string;
    namespace?: string;
    repository?: string;
    'created-at'?: string;
    files: string[];
    'default-branch': string;
    domain?: string;
    config?: string;
    'wait-for-deployment'?: boolean;
    'max-execution-time': number;
    'continue-on-deploy-failures'?: boolean;
    verbose?: boolean;
    format?: Extract<OutputFormat, 'stylish'>;
};
export declare function handlePush(argv: PushOptions, config: Config): Promise<{
    pushId: string;
} | void>;
