import { Config } from '@redocly/openapi-core';
import type { OutputFormat, RuleSeverity } from '@redocly/openapi-core';
import type { RawConfigProcessor } from '@redocly/openapi-core/lib/config';
import type { CommandOptions, Skips } from '../types';
export type LintOptions = {
    apis?: string[];
    'max-problems': number;
    extends?: string[];
    config?: string;
    format: OutputFormat;
    'generate-ignore-file'?: boolean;
    'lint-config'?: RuleSeverity;
} & Omit<Skips, 'skip-decorator'>;
export declare function handleLint(argv: LintOptions, config: Config, version: string): Promise<void>;
export declare function lintConfigCallback(argv: CommandOptions & Record<string, undefined>, version: string): RawConfigProcessor | undefined;
