import { Config, Region } from '@redocly/openapi-core';
import { handlePush as handleCMSPush } from '../cms/commands/push';
export declare const DESTINATION_REGEX: RegExp;
export type PushOptions = {
    api?: string;
    destination?: string;
    branchName?: string;
    upsert?: boolean;
    'job-id'?: string;
    'batch-size'?: number;
    region?: Region;
    'skip-decorator'?: string[];
    public?: boolean;
    files?: string[];
    organization?: string;
    config?: string;
};
export declare function commonPushHandler({ project, 'mount-path': mountPath, }: {
    project?: string;
    'mount-path'?: string;
}): typeof handleCMSPush | (({ apis, branch, "batch-id": batchId, "job-id": jobId, ...rest }: Omit<PushOptions, "destination" | "branchName"> & {
    apis?: string[] | undefined;
    branch?: string | undefined;
    destination?: string | undefined;
} & {
    'batch-id'?: string | undefined;
}, config: Config) => Promise<void>);
export declare function handlePush(argv: PushOptions, config: Config): Promise<void>;
export declare function getDestinationProps(destination: string | undefined, organization: string | undefined): {
    organizationId: string | undefined;
    name: string | undefined;
    version: string | undefined;
};
type BarePushArgs = Omit<PushOptions, 'destination' | 'branchName'> & {
    apis?: string[];
    branch?: string;
    destination?: string;
};
export declare const transformPush: (callback: typeof handlePush) => ({ apis, branch, "batch-id": batchId, "job-id": jobId, ...rest }: BarePushArgs & {
    'batch-id'?: string;
}, config: Config) => Promise<void>;
export declare function getApiRoot({ name, version, config: { apis }, }: {
    name: string;
    version: string;
    config: Config;
}): string;
export {};
