"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_fetch_1 = require("node-fetch");
const abort_controller_1 = require("abort-controller");
const openapi_core_1 = require("@redocly/openapi-core");
const TIMEOUT = 3000;
exports.default = (url, options = {}) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        const controller = new abort_controller_1.default();
        const timeout = setTimeout(() => {
            controller.abort();
        }, TIMEOUT);
        const res = yield (0, node_fetch_1.default)(url, Object.assign(Object.assign({ signal: controller.signal }, options), { agent: (0, openapi_core_1.getProxyAgent)() }));
        clearTimeout(timeout);
        return res;
    }
    catch (e) {
        return;
    }
});
